unit DajShung;

interface

Function Gebruiker : String; //Gebruikersnaam ophalen
Function PC        : String; //PC naam ophalen
Function WinDir    : String; //Windows directory ophalen
Function SysDir    : String; //System Directory ophalen
Function Delphi    : BOOLEAN;//Delphi actief of niet

procedure LogOff;          //Windows afloggen
procedure Reboot;          //Windows reboten
procedure ShutDown;        //Windows afsluiten
procedure ForceTerminate;  //alle programmas sluiten
procedure PowerOff;        //pc uitschakelen
procedure InitDateTime;    //date en time strings ok zetten

procedure MaakSQLAlias (AliasString,Server,User,Database : String);
  //MSSQL alias maken in de BDE
procedure FSplit (TotaalPad : String;var Pad,Naam,Extensie : String);
  //Een volledig pad splisen in pad, naam en extentie
procedure Taakbalk (Hoe : BOOLEAN);
  //Taakbalk laten verdwijnen of opnieuw opkomen

implementation

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBTables;

procedure InitDateTime;

begin
  ShortDateFormat:='dd-MM-yyyy';
  DateSeparator:='-';
  ShortTimeFormat:='hh:mm';
  TimeSeparator:=':';
end;

procedure MaakSQLAlias (AliasString,Server,User,Database : String);

var
  MyList : TStringList;

const
  Driver = 'MSSQL';

begin
  MyList:=TStringList.Create;
  try
    With MyList do
    begin
      Add('SERVER NAME='+Server);
      Add('DATABASE NAME='+Database);
      Add('USER NAME='+User);
    end;
    if Session.IsAlias(AliasString) then
    begin
      Session.DeleteAlias(AliasString);
      Session.SaveConfigFile;
    end;
    Session.AddAlias(AliasString,Driver,MyList);
    Session.SaveConfigFile;
  finally
    myList.Free;
  end;
end;

procedure LogOff;

begin
  ExitWindowsEx(EWX_LOGOFF,0);
end;

procedure PowerOff;

begin
  exitWindowsEx(EWX_POWEROFF,0);
end;

procedure Reboot;

begin
  ExitWindowsEx(EWX_REBOOT,0);
end;

procedure ForceTerminate;

begin
  ExitWindowsEx(EWX_FORCE,0);
end;

procedure ShutDown;

begin
  ExitWindowsEx(EWX_SHUTDOWN,0);
end;

procedure FSplit (TotaalPad : String;var Pad,Naam,Extensie : String);

var
  C,C2 : Byte;
  C3   : Byte;
  Tmp  : String;
  Tmp2 : String;

begin
  Tmp:=TotaalPad;
  Extensie:=Upcase(Tmp[Length(Tmp)-2])+
            Upcase(Tmp[Length(Tmp)-1])+
            Upcase(Tmp[Length(Tmp)-0]);
  C:=Length(Tmp)-3;
  Naam:='';
  Repeat
    Dec(c);
    Naam:=Naam+Upcase(Tmp[c]);
  Until Tmp[C]='\';
  Delete(Naam,Length(Naam),1);
  Tmp2:='';
  For c2:=Length(Naam) Downto 1 do
  begin
    Tmp2:=Tmp2+Naam[c2];
  end;
  Naam:=tmp2;
  Pad:='';
  For C3:=1 to c do
  begin
    Pad:=Pad+Upcase(Tmp[c3]);
  end;
end;

function Delphi : BOOLEAN;

var
  H0,
  H1,
  H2,
  H3,
  H4,
  H5 : HWND;

Const
  A1 : ARRAY[0..12] Of Char = 'TApplication'#0;
  A2 : ARRAY[0..15] Of Char = 'TAlignPalette'#0;
  A3 : ARRAY[0..18] Of Char = 'TPropertyInspector'#0;
  A4 : ARRAY[0..11] Of Char = 'TAppBuilder'#0;
  T1 : ARRAY[0..10] Of Char = 'Delphi 2.0'#0;
  T2 : ARRAY[0..8]  Of Char = 'Delpi 3'#0;
  T3 : ARRAY[0..8]  Of Char = 'Delpi 4'#0;

begin
  H0:=FindWindow(A1,T1);
  H1:=FindWindow(A1,T2);
  H2:=FindWindow(A1,T3);
  H3:=FindWindow(A2,Nil);
  H4:=FindWindow(A3,Nil);
  H5:=FindWindow(A4,Nil);
  Delphi:=((H0<>0) or (H1<>0) or (H2<>0)) and
          (H3<>0) and (H4<>0) and (H5<>0);
end;

procedure Taakbalk (Hoe : BOOLEAN);

var
  TrayHandle : THandle;

begin
  TrayHandle:=FindWindow('Shell_TrayWnd',nil);
  if Hoe then
  begin
    ShowWindow(TrayHandle,SW_RESTORE);
  end;
  if not Hoe then
  begin
    ShowWindow(TrayHandle,SW_HIDE);
  end;
end;

Function WinDir : String;

var
  lpBuffer : PChar;
  nSize    : DWord;

const
  Buff_Size = 255;

begin
  nSize:=Buff_Size;
  lpBuffer:=StrAlloc(Buff_Size);
  GetWindowsDirectory(lpBuffer,nSize);
  WinDir:=String(lpBuffer);
  StrDispose(lpBuffer);
end;

Function SysDir : String;

var
  lpBuffer : PChar;
  nSize    : DWord;

const
  Buff_Size = 255;

begin
  nSize:=Buff_Size;
  lpBuffer:=StrAlloc(Buff_Size);
  GetSystemDirectory(lpBuffer,nSize);
  SysDir:=String(lpBuffer);
  StrDispose(lpBuffer);
end;

Function gebruiker : String;

var
  Temp : PChar;
  Ptr  : DWord;

const
  Buff_Size = 255;

begin
  Ptr:=Buff_Size;
  Temp:=StrAlloc(Buff_Size);
  GetUsername(Temp,ptr);
  Gebruiker:=String(Temp);
  StrDispose(Temp);
end;

Function PC : String;

var
  lpBuffer : PChar;
  nSize    : DWord;

const
  Buff_Size = MAX_COMPUTERNAME_LENGTH + 1;

begin
  nSize:=Buff_Size;
  lpBuffer:=StrAlloc(Buff_Size);
  GetComputerName(lpBuffer,nSize);
  Pc:=String(lpBuffer);
  StrDispose(lpBuffer);
end;

end.
